#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BUFSIZE 2048

int compare(void *m, void *n);
char *readString(int n);
void bubble(char **p, int n);

/***********************************************************
* FUNCTION NAME: readString
*
* DESCRIPTION:  reads a string form stdin and returns a duplicate of it
*
*
* Argument        Type   IO      Description
* ------------- -------- -- --------------------------------
* int           n        I   number of string
* RETURN VALUE: char* duplicate of string read
*
* CHANGES: -
*************************************************************/
char *readString(int n)
{
    static char buf[BUFSIZE];
    printf("Input string %d:\n", n);
    fgets(buf, sizeof(buf), stdin);
    return strdup(buf);
}

/***********************************************************
* FUNCTION NAME: bubble
*
* DESCRIPTION:  sort an array of character strings using bubble method
*
* ARGUMENT LIST:
* Argument        Type   IO      Description
* ------------- -------- -- --------------------------------
* char **       p        I   pointer to array of strings to sort
* int           n        I   size of the array
*
* RETURN VALUE: void
*
* CHANGES: memory area pointed to by p
*************************************************************/
void bubble(char **p, int n)
{
 int i, j;
 char *t;
 for(i = n-1; i >= 0; i--)
   for(j = 1; j <= i; j++)
     if (compare((void *)&p[j-1], (void *)&p[j]))
       { // swap string pointers
         t = p[j-1]; // pointer to 1st string saved in t
         p[j-1] = p[j]; // copy pointer to next element
         p[j] = t; // put saved pointer into next element
       }
}

/***********************************************************
* FUNCTION NAME: compare
*
* DESCRIPTION:  compares to strings
*
* ARGUMENT LIST:
* Argument        Type   IO      Description
* ------------- -------- -- --------------------------------
* void*         m        I  first string
* void*         n        I  second string
* RETURN VALUE: int -1 if less, 0 if eqoal, 1 if greater
*
* CHANGES: -
*************************************************************/
int compare(void *m, void *n)
{
  return strcmp((char *)m, (char *)n);
}
int main()
{
    int i, n = 0;
    char **strings;

    while (n < 1)
    {
        printf("Please input the number of strings: ");
        if (1 != scanf("%d", &n) || n < 0)
        {
            printf("Please input a strictly positive number!\n");
        }
        getchar();
    }
    if (NULL==(strings=(char **)malloc(n * sizeof(char *))))
    {
        fprintf(stderr, "Alloc error for string array\n");
        exit(1);
    }
    for (i = 0; i < n; i++)
    {
        strings[i] = readString(i+1);
        if (!strings[i])
        {
            fprintf(stderr, "Alloc error on reading string %d\n", i);
            exit(1);
        }
    }
    puts("Strings which were read are:\n-------------------------");
    for (i = 0; i < n; i++)
    {
        printf("%02d: %s", i+1, strings[i]);
    }
    bubble(strings, n);
    puts("-------------------------\nStrings in sorted ordere are:\n-------------------------");
    for (i = 0; i < n; i++)
    {
        printf("%02d: %s", i+1, strings[i]);
    }
    return 0;
}
